package com.zt.plat.module.erp.service.erp;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpBomPageReqVO;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpBomRespVO;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpBomSaveReqVO;
import com.zt.plat.module.erp.dal.dataobject.erp.ErpBomDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * ERP物料清单(BOM) Service 接口
 *
 * @author 后台管理
 */
public interface ErpBomService {

    /**
     * 创建ERP物料清单(BOM)
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ErpBomRespVO createErpBom(@Valid ErpBomSaveReqVO createReqVO);

    /**
     * 更新ERP物料清单(BOM)
     *
     * @param updateReqVO 更新信息
     */
    void updateErpBom(@Valid ErpBomSaveReqVO updateReqVO);

    /**
     * 删除ERP物料清单(BOM)
     *
     * @param id 编号
     */
    void deleteErpBom(Long id);

    /**
    * 批量删除ERP物料清单(BOM)
    *
    * @param ids 编号
    */
    void deleteErpBomListByIds(List<Long> ids);

    /**
     * 获得ERP物料清单(BOM)
     *
     * @param id 编号
     * @return ERP物料清单(BOM)
     */
    ErpBomDO getErpBom(Long id);

    /**
     * 获得ERP物料清单(BOM)分页
     *
     * @param pageReqVO 分页查询
     * @return ERP物料清单(BOM)分页
     */
    PageResult<ErpBomDO> getErpBomPage(ErpBomPageReqVO pageReqVO);

    void callErpRfcInterface();

    void submitDataToErp();
}